<?php
defined('_JEXEC') or die('Restricted access');

/**
 * This is a file to add template specific chrome to module rendering.  To use it you would
 * set the style attribute for the given module(s) include in your template to use the style
 * for each given modChrome function.
 *
 * eg.  To render a module mod_test in the sliders style, you would use the following include:
 * <jdoc:include type="module" name="test" style="slider" />
 *
 * This gives template designers ultimate control over how modules are rendered.
 *
 * NOTICE: All chrome wrapping methods should be named: modChrome_{STYLE} and take the same
 * three arguments.
 */


/**
 * Custom module chrome, echos the whole module in a <div> and the header in <h{x}>. The level of
 * the header can be configured through a 'headerLevel' attribute of the <jdoc:include /> tag.
 * Defaults to <h3> if none given
 */
function modChrome_bamboo($module, &$params, &$attribs)
{
	if (!empty ($module->content)) : ?>
		<div class="user_mod">
			<?php if ($module->showtitle) : ?>
				<h3 class="user_top<?php echo $params->get('moduleclass_sfx'); ?>"><?php echo $module->title; ?></h3>
			<?php endif; ?>
			<div class="user_middle<?php echo $params->get('moduleclass_sfx'); ?>">
			<?php echo $module->content; ?>
			</div>
			<div class="user_bottom<?php echo $params->get('moduleclass_sfx'); ?>"></div>
		</div>
	<?php endif;
}

function modChrome_user($module, &$params, &$attribs)
{
	if (!empty ($module->content)) : ?>
		<div class="user_mod<?php echo $params->get('moduleclass_sfx'); ?>">
			<?php if ($module->showtitle) : ?>
				<h3 class="mod_title<?php echo $params->get('moduleclass_sfx'); ?>"><?php echo $module->title; ?></h3>
			<?php endif; ?>
			<?php echo $module->content; ?>
		</div>
	<?php endif;
}
